<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::avs::AVSDirective Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1avs.html">avs</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::avs::AVSDirective Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_a_v_s_directive_8h_source.html">AVSDirective.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::avs::AVSDirective:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html" title="alexaClientSDK::avsCommon\l::avs::AVSMessage" alt="" coords="5,5,202,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::avsCommon::avs::AVSDirective:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_coll__map" id="alexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html" title="alexaClientSDK::avsCommon\l::avs::AVSMessage" alt="" coords="5,5,202,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:aec5d27fc4922b753ff8952280d54000a"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">ParseStatus</a> { <br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c">ParseStatus::SUCCESS</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f">ParseStatus::ERROR_INVALID_JSON</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428">ParseStatus::ERROR_MISSING_DIRECTIVE_KEY</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98">ParseStatus::ERROR_MISSING_HEADER_KEY</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d">ParseStatus::ERROR_MISSING_NAMESPACE_KEY</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb">ParseStatus::ERROR_MISSING_NAME_KEY</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912">ParseStatus::ERROR_MISSING_MESSAGE_ID_KEY</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1">ParseStatus::ERROR_MISSING_PAYLOAD_KEY</a>
<br />
 }</td></tr>
<tr class="separator:aec5d27fc4922b753ff8952280d54000a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4e4da298bd174e8fc41ba0a06d631cbd"><td class="memItemLeft" align="right" valign="top">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">avsCommon::avs::attachment::AttachmentReader</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a4e4da298bd174e8fc41ba0a06d631cbd">getAttachmentReader</a> (const std::string &amp;contentId, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">utils::sds::ReaderPolicy</a> readerPolicy) const</td></tr>
<tr class="separator:a4e4da298bd174e8fc41ba0a06d631cbd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb5210c45e69fb93b2c928f0451ae90c"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#afb5210c45e69fb93b2c928f0451ae90c">getUnparsedDirective</a> () const</td></tr>
<tr class="separator:afb5210c45e69fb93b2c928f0451ae90c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html">alexaClientSDK::avsCommon::avs::AVSMessage</a></td></tr>
<tr class="memitem:a72ec5253158d65661e36e3c0d6bbe9b5 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#a72ec5253158d65661e36e3c0d6bbe9b5">AVSMessage</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message_header.html">AVSMessageHeader</a> &gt; avsMessageHeader, std::string payload)</td></tr>
<tr class="separator:a72ec5253158d65661e36e3c0d6bbe9b5 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d627fccb19e3ed8c41bcebe2f70cf95 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#a7d627fccb19e3ed8c41bcebe2f70cf95">~AVSMessage</a> ()=default</td></tr>
<tr class="separator:a7d627fccb19e3ed8c41bcebe2f70cf95 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ebabd97c517bae88c7d603fcfb87bcc inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#a5ebabd97c517bae88c7d603fcfb87bcc">getNamespace</a> () const</td></tr>
<tr class="separator:a5ebabd97c517bae88c7d603fcfb87bcc inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a981b7906efc4c308ac03d22399cedb73 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#a981b7906efc4c308ac03d22399cedb73">getName</a> () const</td></tr>
<tr class="separator:a981b7906efc4c308ac03d22399cedb73 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb2b027b4e99b1e632b7bf166d9aa45b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#afb2b027b4e99b1e632b7bf166d9aa45b">getMessageId</a> () const</td></tr>
<tr class="separator:afb2b027b4e99b1e632b7bf166d9aa45b inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aacaad263dc208cef2908fc6115ca7fc1 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#aacaad263dc208cef2908fc6115ca7fc1">getDialogRequestId</a> () const</td></tr>
<tr class="separator:aacaad263dc208cef2908fc6115ca7fc1 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acca684e8fe9bdae5cc2f5477a9f43825 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#acca684e8fe9bdae5cc2f5477a9f43825">getPayload</a> () const</td></tr>
<tr class="separator:acca684e8fe9bdae5cc2f5477a9f43825 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae6578ea07b4e72137b7a8783bb049c8d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message.html#ae6578ea07b4e72137b7a8783bb049c8d">getHeaderAsString</a> () const</td></tr>
<tr class="separator:ae6578ea07b4e72137b7a8783bb049c8d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a8e9e239c6457e43dd261dad01482be7e"><td class="memItemLeft" align="right" valign="top">static std::pair&lt; std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> &gt;, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">ParseStatus</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a8e9e239c6457e43dd261dad01482be7e">create</a> (const std::string &amp;unparsedDirective, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt; attachmentManager, const std::string &amp;attachmentContextId)</td></tr>
<tr class="separator:a8e9e239c6457e43dd261dad01482be7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5687e93246d39d75f901505767e21b52"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#a5687e93246d39d75f901505767e21b52">create</a> (const std::string &amp;unparsedDirective, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message_header.html">AVSMessageHeader</a> &gt; avsMessageHeader, const std::string &amp;payload, std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt; attachmentManager, const std::string &amp;attachmentContextId)</td></tr>
<tr class="separator:a5687e93246d39d75f901505767e21b52"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A class representation of the AVS directive. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="aec5d27fc4922b753ff8952280d54000a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aec5d27fc4922b753ff8952280d54000a">&#9670;&nbsp;</a></span>ParseStatus</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">alexaClientSDK::avsCommon::avs::AVSDirective::ParseStatus</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">An enum to indicate the status of parsing an AVS Directive from a JSON string representation. </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aad0749aaba8b833466dfcbb0428e4f89c"></a>SUCCESS&#160;</td><td class="fielddoc"><p class="">The parse was successful. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aa0cd012636a45bdff34a0a011c219f75f"></a>ERROR_INVALID_JSON&#160;</td><td class="fielddoc"><p class="">The parse failed due to invalid JSON formatting. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aa4468ffaec2d10cfc0afc4875884b2428"></a>ERROR_MISSING_DIRECTIVE_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the directive key being missing. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aa2928fbc5b71d4e4495c534d6d7428f98"></a>ERROR_MISSING_HEADER_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the header key being missing. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aa00080eacc84508834c95ee3a4208479d"></a>ERROR_MISSING_NAMESPACE_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the namespace key being missing. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aa40df3f73742319aee259a2097e988eeb"></a>ERROR_MISSING_NAME_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the name key being missing. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aacd0d709786ee43c9798ba52689dde912"></a>ERROR_MISSING_MESSAGE_ID_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the message id key being missing. </p>
</td></tr>
<tr><td class="fieldname"><a id="aec5d27fc4922b753ff8952280d54000aac29847d86d1e896be9adb2c271b1cba1"></a>ERROR_MISSING_PAYLOAD_KEY&#160;</td><td class="fielddoc"><p class="">The parse failed due to the message payload key being missing. </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a8e9e239c6457e43dd261dad01482be7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e9e239c6457e43dd261dad01482be7e">&#9670;&nbsp;</a></span>create() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::pair&lt;std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a>&gt;, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html#aec5d27fc4922b753ff8952280d54000a">ParseStatus</a>&gt; alexaClientSDK::avsCommon::avs::AVSDirective::create </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>unparsedDirective</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>attachmentContextId</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">unparsedDirective</td><td>The unparsed AVS Directive JSON string. </td></tr>
    <tr><td class="paramname">attachmentManager</td><td>The attachment manager. </td></tr>
    <tr><td class="paramname">attachmentContextId</td><td>The contextId required to get attachments from the AttachmentManager. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A pair of an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> pointer and a parse status. If the <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> is nullptr, the status will express the parse error. </dd></dl>

</div>
</div>
<a id="a5687e93246d39d75f901505767e21b52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5687e93246d39d75f901505767e21b52">&#9670;&nbsp;</a></span>create() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::unique_ptr&lt;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a>&gt; alexaClientSDK::avsCommon::avs::AVSDirective::create </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>unparsedDirective</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_message_header.html">AVSMessageHeader</a> &gt;&#160;</td>
          <td class="paramname"><em>avsMessageHeader</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>payload</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_manager_interface.html">avsCommon::avs::attachment::AttachmentManagerInterface</a> &gt;&#160;</td>
          <td class="paramname"><em>attachmentManager</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>attachmentContextId</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates an <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">unparsedDirective</td><td>The unparsed AVS Directive JSON string. </td></tr>
    <tr><td class="paramname">avsMessageHeader</td><td>The header fields of the Directive. </td></tr>
    <tr><td class="paramname">payload</td><td>The payload of the Directive. </td></tr>
    <tr><td class="paramname">attachmentManager</td><td>The attachment manager. </td></tr>
    <tr><td class="paramname">attachmentContextId</td><td>The contextId required to get attachments from the AttachmentManager. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The created <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">AVSDirective</a> object or <code>nullptr</code> if creation failed. </dd></dl>

</div>
</div>
<a id="a4e4da298bd174e8fc41ba0a06d631cbd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4e4da298bd174e8fc41ba0a06d631cbd">&#9670;&nbsp;</a></span>getAttachmentReader()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_reader.html">AttachmentReader</a> &gt; alexaClientSDK::avsCommon::avs::AVSDirective::getAttachmentReader </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>contentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a07d2a9441f40d089a1f9a0d7e2baab4b">utils::sds::ReaderPolicy</a>&#160;</td>
          <td class="paramname"><em>readerPolicy</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Returns a reader for the attachment associated with this directive.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">contentId</td><td>The contentId associated with the attachment. </td></tr>
    <tr><td class="paramname">readerPolicy</td><td>The policy with which to create the <code>AttachmentReader</code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>An attachment reader or <code>nullptr</code> if no attachment was found with the given <code>contentId</code>. </dd></dl>

</div>
</div>
<a id="afb5210c45e69fb93b2c928f0451ae90c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afb5210c45e69fb93b2c928f0451ae90c">&#9670;&nbsp;</a></span>getUnparsedDirective()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string alexaClientSDK::avsCommon::avs::AVSDirective::getUnparsedDirective </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Returns the underlying unparsed directive. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/include/AVSCommon/AVS/<a class="el" href="_a_v_s_directive_8h_source.html">AVSDirective.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/AVS/src/<a class="el" href="_a_v_s_directive_8cpp.html">AVSDirective.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
